package com.jasamedika.medifirst2000.controller;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PraAnestesiDokterBedahService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.PraAnestesiDokterBedahHeaderVO;
import com.jasamedika.medifirst2000.vo.PraAnestesiDokterBedahVO;
import com.jasamedika.medifirst2000.vo.PraAnestesiPasienHeaderVO;


@RestController
@RequestMapping("/pra-anestesi-dokter-bedah")
public class PraAnestesiDokterBedahController extends LocaleController<PraAnestesiDokterBedahVO>{
	private static final Logger LOGGER = LoggerFactory.getLogger(PraAnestesiDokterBedahController.class);
	
	@Autowired
	private PraAnestesiDokterBedahService praAnestesiDokterBedahService;
	
	@RequestMapping(
			value = "/save-anestesi-dokter-bedah", 
			method = RequestMethod.POST, 
			produces = MediaType.APPLICATION_JSON_VALUE, 
			consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveAnestesiDokterBedah(
			@Valid @RequestBody List<PraAnestesiDokterBedahVO> vos,
			HttpServletRequest request) {

		try {
			Map<String, Object> result = this.praAnestesiDokterBedahService.savePraAnestesiDokterBedah(vos);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
						getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when saveAnestesiDokterBedah", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when saveAnestesiDokterBedah", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}
	
	@RequestMapping(
			value = "/save-anestesi-dokter-bedah-rev1", 
			method = RequestMethod.POST, 
			produces = MediaType.APPLICATION_JSON_VALUE, 
			consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveAnestesiDokterBedahRev1(@Valid @RequestBody PraAnestesiDokterBedahHeaderVO vo,
			HttpServletRequest request) {

		try {
			Map<String, Object> result = this.praAnestesiDokterBedahService.savePraAnestesiDokter(vo);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
						getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when saveAnestesiDokterBedahRev1", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when saveAnestesiDokterBedahRev1", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}
	
	@RequestMapping(
			value = "/get-pranestesi-dokter-by-norec", 
			  method = RequestMethod.GET, 
			    produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getPraAnestesiDokterByNoRec(
			@RequestParam(value = "noRec", required = true) String noRec, HttpServletRequest request){
		
		try {
			Map<String,Object> result = this.praAnestesiDokterBedahService.getPraAnestesiDokterByNoRec(noRec);
			
			if (null != result){
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request));
				return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
				
			} else{
				return RestUtil.getJsonResponse(result, HttpStatus.NOT_FOUND,mapHeaderMessage);
				
			}
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when getPraAnestesiDokterByNoRec", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when getPraAnestesiDokterByNoRec", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
			
		}
	}
	
	@RequestMapping(
			value = "/get-pranestesi-dokter-norec-antrian", 
			  method = RequestMethod.GET, 
			    produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getPraAnestesiDokterByNoRecAntrian(
			@RequestParam(value = "noRec", required = true) String noRec, HttpServletRequest request){
		
		try {
			Map<String,Object> result = this.praAnestesiDokterBedahService.getPraAnestesiDokterByNoRecAntrian(noRec);
			
			if (null != result){
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request));
				return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
				
			} else{
				return RestUtil.getJsonResponse(result, HttpStatus.NOT_FOUND,mapHeaderMessage);
				
			}
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when getPraAnestesiDokterByNoRecAntrian", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when getPraAnestesiDokterByNoRecAntrian", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
			
		}
	}


}
